/**
 */
package net.tonreg.emf.edapt.extension;

import net.tonreg.emf.edapt.base.BasePackage;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each operation of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see net.tonreg.emf.edapt.extension.ExtensionFactory
 * @model kind="package"
 * @generated
 */
public interface ExtensionPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "extension";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.tonreg.net/emf/models/extension.ecore/1.0";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "extension";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	ExtensionPackage eINSTANCE = net.tonreg.emf.edapt.extension.impl.ExtensionPackageImpl.init();

	/**
	 * The meta object id for the '{@link net.tonreg.emf.edapt.extension.impl.CustomerRequestImpl <em>Customer Request</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.tonreg.emf.edapt.extension.impl.CustomerRequestImpl
	 * @see net.tonreg.emf.edapt.extension.impl.ExtensionPackageImpl#getCustomerRequest()
	 * @generated
	 */
	int CUSTOMER_REQUEST = 0;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CUSTOMER_REQUEST__ID = BasePackage.REQUEST__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CUSTOMER_REQUEST__NAME = BasePackage.REQUEST__NAME;

	/**
	 * The feature id for the '<em><b>Created</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CUSTOMER_REQUEST__CREATED = BasePackage.REQUEST__CREATED;

	/**
	 * The feature id for the '<em><b>Created By</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CUSTOMER_REQUEST__CREATED_BY = BasePackage.REQUEST__CREATED_BY;

	/**
	 * The feature id for the '<em><b>Title</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CUSTOMER_REQUEST__TITLE = BasePackage.REQUEST__TITLE;

	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CUSTOMER_REQUEST__TYPE = BasePackage.REQUEST__TYPE;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CUSTOMER_REQUEST__DESCRIPTION = BasePackage.REQUEST__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Tasks</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CUSTOMER_REQUEST__TASKS = BasePackage.REQUEST__TASKS;

	/**
	 * The feature id for the '<em><b>Customer Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CUSTOMER_REQUEST__CUSTOMER_NAME = BasePackage.REQUEST_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Note</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CUSTOMER_REQUEST__NOTE = BasePackage.REQUEST_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Customer Request</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CUSTOMER_REQUEST_FEATURE_COUNT = BasePackage.REQUEST_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Customer Request</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CUSTOMER_REQUEST_OPERATION_COUNT = BasePackage.REQUEST_OPERATION_COUNT + 0;


	/**
	 * Returns the meta object for class '{@link net.tonreg.emf.edapt.extension.CustomerRequest <em>Customer Request</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Customer Request</em>'.
	 * @see net.tonreg.emf.edapt.extension.CustomerRequest
	 * @generated
	 */
	EClass getCustomerRequest();

	/**
	 * Returns the meta object for the attribute '{@link net.tonreg.emf.edapt.extension.CustomerRequest#getCustomerName <em>Customer Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Customer Name</em>'.
	 * @see net.tonreg.emf.edapt.extension.CustomerRequest#getCustomerName()
	 * @see #getCustomerRequest()
	 * @generated
	 */
	EAttribute getCustomerRequest_CustomerName();

	/**
	 * Returns the meta object for the attribute '{@link net.tonreg.emf.edapt.extension.CustomerRequest#getNote <em>Note</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Note</em>'.
	 * @see net.tonreg.emf.edapt.extension.CustomerRequest#getNote()
	 * @see #getCustomerRequest()
	 * @generated
	 */
	EAttribute getCustomerRequest_Note();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	ExtensionFactory getExtensionFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each operation of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link net.tonreg.emf.edapt.extension.impl.CustomerRequestImpl <em>Customer Request</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.tonreg.emf.edapt.extension.impl.CustomerRequestImpl
		 * @see net.tonreg.emf.edapt.extension.impl.ExtensionPackageImpl#getCustomerRequest()
		 * @generated
		 */
		EClass CUSTOMER_REQUEST = eINSTANCE.getCustomerRequest();

		/**
		 * The meta object literal for the '<em><b>Customer Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CUSTOMER_REQUEST__CUSTOMER_NAME = eINSTANCE.getCustomerRequest_CustomerName();

		/**
		 * The meta object literal for the '<em><b>Note</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CUSTOMER_REQUEST__NOTE = eINSTANCE.getCustomerRequest_Note();

	}

} //ExtensionPackage
